% Checks if the generated set {Thetas} is within the search space.
% The condition is:
% \forall v \in searchSpace \exists k = 1,...,m \Theta_k \geq v_k
function inSearchSpace = are_thetas_in_search_space(thetas, searchSpace)

inSearchSpace = 0;

for i = 1:length(searchSpace)
    v = searchSpace{i};
    k_found = 0;
    
    for k = 1:numel(thetas)
        v_k = v(k);
        theta_k = thetas(k);
        
        if (theta_k >= v_k)
            k_found = 1;
            break;
        end
    end
    
    if (k_found == 0)
        % For this vector in search space
        % no k exists such that \Theta_k >= v_k
        % and this set {Theta} is outside the search space
        return;
    end      
end

% for any vector in search space
% the condition holds
inSearchSpace = 1;

end