% Gets interfering workloads for EDF and FP
% according to Bertogna
function tasks = get_interfering_workloads(tasks)

tasks = assign_fixed_priorities(tasks); % for FP we use RM priorities

for index = 1:numel(tasks)
    tasks(index).Wedf = get_interfering_workload_EDF(index, tasks);
    tasks(index).Wfp = get_interfering_workload_FP(index, tasks);
end

end





% get interfering workload Wk for GEDF
function Wi = get_interfering_workload_EDF(i, taskSet)

n = numel(taskSet);
Wi = 0;
Di = taskSet(i).D;

for j = 1:n
    
    if (j ~= i)
        Cj = taskSet(j).C;
        Tj = taskSet(j).T;
    
        Wi = Wi + floor(Di / Tj)*Cj + min(Cj, Di - floor(Di / Tj)*Tj);
    end
end

end




function Wi = get_interfering_workload_FP(i,tasks)

Wi = 0;

for j = 1:(i-1)
    Nji = floor((tasks(i).D + tasks(j).D - tasks(j).C)/tasks(j).T);
    Wji = Nji*tasks(j).C + min(tasks(j).C, tasks(i).D + tasks(j).D - tasks(j).C - Nji*tasks(j).T);
    Wi = Wi + Wji;
end

end