function plot_gmpr_psf_family(Pi, thetas, tMin, tMax)

m = numel(thetas);
colorSet = varycolor(m);

for k = 1:m
    curColor = colorSet(k,:);
    plot_gmpr_psf_k(Pi, thetas, tMin, tMax, k, curColor);
end

% plot parameters
set(gcf, 'Position', [0 0 1200 800]);
hold off;

grid on;
grid minor;

plotLabel = strcat('PSFs for GMPR <', num2str(Pi), ', \{', num2str(thetas), '\}>');
title(plotLabel, 'FontWeight', 'bold', 'FontSize', 12, 'Color', 'black')
xlabel('t', 'FontSize', 12)
ylabel('Sbf(t)', 'FontSize', 12)

end